// Copyright 2000--2006 Bluespec, Inc.  All rights reserved.

`ifdef BSV_ASSIGNMENT_DELAY
`else
`define BSV_ASSIGNMENT_DELAY
`endif


module MakeReset0 (
		  CLK,
		  RST_N,
                  ASSERT,
		  ASSERT_OUT,

                  OUT_RST_N
                  );
  
   parameter          init = 1 ;

   input              CLK ;
   input              RST_N ;
   input              ASSERT ;
   output             ASSERT_OUT ;

   output             OUT_RST_N ;

   reg                rst ;

   assign ASSERT_OUT = !rst ;

   assign OUT_RST_N = rst ;

   always@(posedge CLK or negedge RST_N) begin
      if (!RST_N)
        rst <= `BSV_ASSIGNMENT_DELAY init;
      else if (ASSERT)
        rst <= `BSV_ASSIGNMENT_DELAY 1'b0;
      else // if (rst == 1'b0)
	rst <= `BSV_ASSIGNMENT_DELAY 1'b1;
   end

`ifdef BSV_NO_INITIAL_BLOCKS
`else // not BSV_NO_INITIAL_BLOCKS
   // synopsys translate_off
   initial begin
      rst = 1'b1 ;
   end
   // synopsys translate_on
`endif // BSV_NO_INITIAL_BLOCKS

endmodule // MakeReset0
