// Copyright 2000--2006 Bluespec, Inc.  All rights reserved.

`ifdef BSV_ASSIGNMENT_DELAY
`else
`define BSV_ASSIGNMENT_DELAY
`endif


module McpRegUN(CLK, RST_N, SET, val, get);
   // synopsys template   
   parameter width = 1;
   parameter delay = 0;

   input     CLK;
   input     RST_N;
   input     SET;
   input [width - 1 : 0] val;
   output [width - 1 : 0] get;

   reg [width - 1 : 0]    get;

`ifdef DC
`else
   wire [width - 1 : 0]   #delay delayed_val = val;
   wire [width - 1 : 0]   output_val = (val === delayed_val ? val : {width{1'bx}});
`endif
   
   always@(posedge CLK)
     begin
        if (!RST_N)
          begin
             get <= `BSV_ASSIGNMENT_DELAY {((width + 1)/2){2'b10}} ;
          end
        else if (SET)
          begin
`ifdef DC      
             get <= `BSV_ASSIGNMENT_DELAY val;
`else
             get <= `BSV_ASSIGNMENT_DELAY output_val;
`endif
          end
   end // always@ (posedge CLK)


`ifdef BSV_NO_INITIAL_BLOCKS
`else // not BSV_NO_INITIAL_BLOCKS
   // synopsys translate_off
   initial begin
      get = {((width + 1)/2){2'b10}} ;
   end
   // synopsys translate_on
`endif // BSV_NO_INITIAL_BLOCKS
   
endmodule

