signature Utils where {
import BRAMInitiatorWires;
			 
import BRAMTargetWires;
		      
import Clocks;
		
import Environment;
		     
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import FixedPoint;
		    
import List;
	      
import ListN;
	       
import Parameters;
		 
import PrimArray;
		   
import Vector;
		
import Complex16;
		
import Connectable;
		     
import GetPut;
		
import PLBMasterWires;
		     
import Types;
	    
import Interfaces;
		 
Utils.showReg :: Types.MatrixRegister -> Prelude.String;
							     
Utils.showFunctionalUnitOp :: Types.FunctionalUnitOp -> Prelude.String;
									    
Utils.showInst :: Types.Instruction -> Prelude.Action;
							   
Utils.displayInst :: Types.Instruction -> Prelude.Action;
							      
Utils.splitInst :: Types.Instruction ->
		   Prelude.Tuple2 (Prelude.Bit 32) (Prelude.Bit 32);
										     
Utils.fuseInst :: Prelude.Bit 32 -> Prelude.Bit 32 -> Types.Instruction;
										   
Utils.oneHot :: (Prelude.Log m n) => Prelude.Bit n -> Prelude.Bit m;
										     
Utils.getLink :: Interfaces.FunctionalUnit t -> Interfaces.FUNetworkLink;
									
instance FixedPoint Prelude.Eq (FixedPoint.FixedPoint isize fsize);
										       
instance FixedPoint Prelude.Bits (FixedPoint.FixedPoint isize fsize)
		       (Prelude.TAdd isize fsize);
							     
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Bounded (FixedPoint.FixedPoint i f);
										    
instance FixedPoint (Prelude.Add i f (Prelude.TAdd i f),
			Prelude.Add 1 xxx i) =>
		       Prelude.Arith (FixedPoint.FixedPoint i f);
										  
instance FixedPoint (Prelude.Add 1 xxx i,
			Prelude.Add i f (Prelude.TAdd i f)) =>
		       Prelude.Literal (FixedPoint.FixedPoint i f);
										    
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Ord (FixedPoint.FixedPoint i f);
										
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Bitwise (FixedPoint.FixedPoint i f);
										    
instance ListN (Prelude.Eq (Prelude.List a)) =>
		  Prelude.Eq (ListN.ListN n a);
								
instance ListN (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		  Prelude.Bits (ListN.ListN n a) nsa;
									 
instance ListN Prelude.PrimSelectable (ListN.ListN n a) a;
										 
instance ListN Prelude.PrimUpdateable (ListN.ListN n a) a;
										 
instance Vector (Prelude.Eq (Prelude.PrimArray a)) =>
		   Prelude.Eq (Vector.Vector n a);
								   
instance Vector (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		   Prelude.Bits (Vector.Vector n a) nsa;
									    
instance Vector (Prelude.Bounded a, Prelude.Bits a sa) =>
		   Prelude.Bounded (Vector.Vector n a);
									
instance Vector Prelude.PrimSelectable (Vector.Vector n a) a;
										    
instance Vector Prelude.PrimUpdateable (Vector.Vector n a) a;
										    
instance Complex16 Prelude.Eq Complex16.Complex16;
						       
instance Complex16 Prelude.Bits Complex16.Complex16 32;
							    
instance Complex16 Prelude.Literal Complex16.Complex16;
							    
instance Complex16 Prelude.Bounded Complex16.Complex16;
							    
instance Complex16 Prelude.Arith Complex16.Complex16;
							  
instance Connectable (Connectable.Connectable a b,
			 Connectable.Connectable c d) =>
			Connectable.Connectable (a, c) (b, d);
									       
instance Connectable (Connectable.Connectable a b) =>
			Connectable.Connectable (Vector.Vector n a) (Vector.Vector n b);
														     
instance Connectable (Connectable.Connectable a b) =>
			Connectable.Connectable (ListN.ListN n a) (ListN.ListN n b);
														 
instance Connectable Connectable.Connectable (PreludeBSV.RWire a)
			(PreludeBSV.RWire a);
						     
instance Connectable Connectable.Connectable (Prelude.ActionValue a)
			(a -> Prelude.Action);
						      
instance Connectable Connectable.Connectable (a -> Prelude.Action)
			(Prelude.ActionValue a);
							
instance GetPut Connectable.Connectable (GetPut.Get a) (GetPut.Put a);
												
instance GetPut Connectable.Connectable (GetPut.Put a) (GetPut.Get a);
												
instance GetPut (Prelude.Bits a sa) =>
		   Prelude.ClockConv (GetPut.Get a);
								  
instance GetPut (Prelude.Bits a sa) =>
		   Prelude.ClockConv (GetPut.Put a);
								  
instance Types Prelude.Bits Types.MatrixRegister 2;
							
instance Types Prelude.Eq Types.MatrixRegister;
						    
instance Types Prelude.Bits Types.FunctionalUnitOp 3;
							  
instance Types Prelude.Eq Types.FunctionalUnitOp;
						      
instance Types Prelude.Bits Types.PLBMasterCommand 32;
							   
instance Types Prelude.Eq Types.PLBMasterCommand;
						      
instance Types Prelude.Bits Types.MemorySwitchCommand 2;
							     
instance Types Prelude.Eq Types.MemorySwitchCommand;
							 
instance Types Prelude.Bits Types.FUNetworkCommand 5;
							  
instance Types Prelude.Eq Types.FUNetworkCommand;
						      
instance Types Prelude.Bits Types.FunctionalUnitCommand 6;
							       
instance Types Prelude.Eq Types.FunctionalUnitCommand;
							   
instance Types Prelude.Bits Types.Instruction 38;
						      
instance Types Prelude.Eq Types.Instruction;
						 
instance Types Prelude.Bits Types.Instruction\xb0\x41rithmeticInstruction 4;
										   
instance Types Prelude.Eq Types.Instruction\xb0\x41rithmeticInstruction;
									       
instance Types Prelude.Bits Types.Instruction\xb0LoadInstruction 35;
									   
instance Types Prelude.Eq Types.Instruction\xb0LoadInstruction;
								      
instance Types Prelude.Bits Types.Instruction\xb0StoreInstruction 34;
									    
instance Types Prelude.Eq Types.Instruction\xb0StoreInstruction;
								       
instance Types Prelude.Bits Types.Instruction\xb0\x46orwardInstruction 5;
										
instance Types Prelude.Eq Types.Instruction\xb0\x46orwardInstruction;
									    
instance Types Prelude.Eq Types.FeederState;
						 
instance Types Prelude.Bits Types.FeederState 4;
						     
type (Complex16.Complex16 :: *);
			       
class (Connectable.Connectable :: * -> * -> *) a b | a -> b, b -> a;
									 
type (FixedPoint.FixedPoint :: # -> # -> *) _v100 _v101;
							     
type (GetPut.Get :: * -> *) _v100;
				       
type (GetPut.Put :: * -> *) _v100;
				       
type (Interfaces.FUNetworkLink :: *);
				    
type (Interfaces.FunctionalUnit :: # -> *) _v100;
						
type (ListN.ListN :: # -> * -> *) _v100 _v101;
						   
type (Types.FUNetworkCommand :: *);
				  
type (Types.FeederState :: *);
			     
type (Types.FunctionalUnitCommand :: *);
				       
type (Types.FunctionalUnitOp :: *);
				  
type (Types.Instruction :: *);
			     
type (Types.Instruction\xb0\x41rithmeticInstruction :: *);
							   
type (Types.Instruction\xb0\x46orwardInstruction :: *);
							
type (Types.Instruction\xb0LoadInstruction :: *);
						  
type (Types.Instruction\xb0StoreInstruction :: *);
						   
type (Types.MatrixRegister :: *);
				
type (Types.MemorySwitchCommand :: *);
				     
type (Types.PLBMasterCommand :: *);
				  
type (Vector.Vector :: # -> * -> *) _v100 _v101
}
